#ifndef __GARGOYLE_CODEX_H_
#define __GARGOYLE_CODEX_H_

#include <stdint.h>

typedef uint8_t gargoyle_opt_type;

static const gargoyle_opt_type GARGOYLE_TYPE_BOOL = 1 << 0;
static const gargoyle_opt_type GARGOYLE_TYPE_DBLE = 1 << 3;
static const gargoyle_opt_type GARGOYLE_TYPE_UINT = 1 << 1;
static const gargoyle_opt_type GARGOYLE_TYPE_ROPE = 1 << 4;
static const gargoyle_opt_type GARGOYLE_TYPE_SINT = 1 << 2;

typedef uint8_t gargoyle_err_type;

static const gargoyle_err_type GARGOYLE_ERR_SUCCESS = 0;

static const gargoyle_err_type GARGOYLE_ERR_INVALID_DBLE = 1 << 4;
static const gargoyle_err_type GARGOYLE_ERR_INVALID_SINT = 1 << 3;
static const gargoyle_err_type GARGOYLE_ERR_INVALID_UINT = 1 << 2;
static const gargoyle_err_type GARGOYLE_ERR_UNKNOWN_OPTN = 1 << 0;
static const gargoyle_err_type GARGOYLE_ERR_UNKNOWN_TYPE = 1 << 5;
static const gargoyle_err_type GARGOYLE_ERR_VAL_REQUIRED = 1 << 1;

typedef uint8_t gargoyle_flag_type;

static const gargoyle_flag_type GARGOYLE_FLG_BCASE = 1 << 0;
static const gargoyle_flag_type GARGOYLE_FLG_ECASE = 1 << 1;
static const gargoyle_flag_type GARGOYLE_FLG_FILL0 = 1 << 5;
static const gargoyle_flag_type GARGOYLE_FLG_GREED = 1 << 4;
static const gargoyle_flag_type GARGOYLE_FLG_ICASE = 1 << 2;
static const gargoyle_flag_type GARGOYLE_FLG_STRCT = 1 << 6;
static const gargoyle_flag_type GARGOYLE_FLG_SYMBL = 1 << 3;

static const gargoyle_flag_type GARGOYLE_FLG_FLXBL = GARGOYLE_FLG_BCASE |
                                                     GARGOYLE_FLG_ECASE |
                                                     GARGOYLE_FLG_ICASE |
                                                     GARGOYLE_FLG_SYMBL;

#endif
